/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  lpimisc.h

\***************************************************************************/

/*--------------------------------------------------------------------------
   Name:          CFreeString
   Description:   Free a string in memory.  Frees strings of length
                  strlen()+1, sets the pointer to LNULL on return if
                  successful
                  Uses VMR_1
   Inputs:        lptr(CONTEXT)  LpiContext
                                 far pointer to the primitive module globals
                  lmhdl(lmbcs)   str
                                 lmhdl to string to be freed
   Outputs:       lmhdl(lmbcs)   LNULL if successfully freed, ptr if not
\*-------------------------------------------------------------------------*/
lmhdl(lmbcs) CFreeString ( lptr(CONTEXT), lmhdl(lmbcs) );
/*-------------------------------------------------------------------------
  Name:        CCopyString
  Description: Make a copy of a string in memory. This routine is used
               to make copies of the Prompt Title and Default strings
               when creating the strings and when cloning an ADT instance.
               Uses VMR_2, VMR_3
  Inputs:      lptr(CONTEXT)
                  far pointer to the primitive module globals
               lmhdl(char)
                  mptr to the string to copy
  Outputs:     lmhdl(char)
                  mptr to the newly allocated string
                  NULL_MPTR if we ran out of memory
\*-------------------------------------------------------------------------*/
lmhdl(lmbcs) CCopyString (lptr(CONTEXT), lmhdl(lmbcs));
