--**************************************************************************
--
--   Copyright (C) 1991-1994 Lotus Development Corporation.
--   All rights reserved.
--
--   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
--       the source code version and to reproduce and distribute the object
--       code version of the Example Programs provided in the Toolkit, provided
--       that you:
--
--       a) distribute the Example Programs only in conjunction with and as a
--          part of your software application product which is designed as an
--          add-in to Lotus 1-2-3, and
--
--       b) do not represent your product to be a product of Lotus Development
--          Corporation.
--
--   2.  The Example Programs are provided as is, without warranty of any kind,
--       either express or implied, including, without limitation, the implied
--       warranties of merchantability of fitness for a particular purpose.
--
--   File Name:  xalert.pl
--
--**************************************************************************

module Xalert is   -- a general purpose alert box, that accepts four
                   -- string variables, centers them in the box,
                   -- chirps when the user can read the box,
                   -- and goes away with the pressing of any key.
use Window,
    Input,
    AtStr,
    Utility,     -- for Beep()
    Register

   register("Alert",macro)  -- makes Alert a macro command.
------------------------------------------------------------------------------
------------------------------------------------------------------------------
procedure CenterString(string InString, integer FixedLength)
                               returns(string OutString) is

-- designed to take a string, and pad space characters to it, so it will
-- be centered within a Fixed Length.
-- First, the length of the incoming string is compared to the Fixed
-- Length.  If it is not too long, it is giving leading spaces.  Otherwise
-- it is truncated.

       if FixedLength > length(InString) then
               OutString =  repeat(" ",(FixedLength-length(InString)) div 2 - 1)
                                                || InString
       else
      OutString = left(InString,FixedLength-2)
       end if

end procedure CenterString
------------------------------------------------------------------------------
------------------------------------------------------------------------------
procedure Alert (string s1,s2,s3,s4) is  -- s1 through s4 are the strings.

       display[] d
       -- required to know how many lines in the display, for centering the box.

       KeyBoard[] user
       -- required to wait for user to hit a key.

       integer BoxHeight = 11
       integer BoxWidth = 42

       window[BoxWidth,BoxHeight,Single] AlertWin

       AlertWin.Foreground(DefaultArea) = HighLight
       AlertWin.Background(DefaultArea) = Flash

       AlertWin.Position =     ((d.Width  - BoxWidth)  DIV 2),
                                                       ((d.Height - BoxHeight) DIV 2)
       -- center the box

       AlertWin[1] = CenterString("!!! Alert !!!",BoxWidth)
       AlertWin[2] = " "
       AlertWin[3] = CenterString(s1,BoxWidth)
       AlertWin[4] = CenterString(s2,BoxWidth)
       AlertWin[5] = CenterString(s3,BoxWidth)
       AlertWin[6] = CenterString(s4,BoxWidth)
       AlertWin[7] = " "
       AlertWin[8] = CenterString("Press any key to continue",BoxWidth)

       AlertWin.enabled = true
       -- window is drawn once text has been filled in.

       beep(1000,100) beep(2000,100) beep(3000,100)

       string key = input(user)
               except on others do return
               end except
       -- any key ends the procedure

end procedure Alert
------------------------------------------------------------------------------
------------------------------------------------------------------------------

end module Xalert
